VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsConsole"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'******************************************************************************
'                               :
'
'Public oConsole As clsConsole       '  .
'
'Sub Main()
'   Dim sText As String * 15         '  .  . 
'
'   Set oConsole = New clsConsole                  ' 
'   With oConsole
'      .Load                                       ' 
'      .Hide                                       '  , 
'                                                  '     
'                                                  '   .
'      .Title "!"                       '  .
'      .ReportPath = "D:\log.txt"                  '   
'      .Color FCOL_Black, BCOL_WhiteBright         '   
'      .WriteLn "Hello!", False                    '   
'                                                  '    -
'                                                  '.   
'                                                  '  Char()
'      .WriteEmptyRows (2)                         ' 2-  
'      .WriteX " ( 15- .): "             '   
'                                                  '   -
'                                                  ' ( ).
'      MsgBox "  !"
'      .Show                                       ' .
'      sText = .ReadLn                             '   -
'                                                  '.
'      .ConsoleTablesIndent = 10                   '   
'      .BorderStyle = ConsoleBorderDouble          '  
'      .Table LN_TOP, sText                        '  
'      .Table LN_CONTENT, sText                    ' 
'      .Table LN_BOTTOM, sText                     '  
'      .Unload                                     ' .
'   End With
'   Set oConsole = Nothing                         ' .
'End Sub

Private Const HEADER = _
"              ******************************************" & vbCrLf & _
"              *    :    !   *" & vbCrLf & _
"              *      . *" & vbCrLf & _
"              ******************************************" & vbCrLf

Private Declare Function _
   AllocConsole Lib "kernel32" () As Long         ' .

Private Enum ShowWindowCmd          '  ShowWindow
   SW_HIDE = 0                      '     
   SW_MAXIMIZE = 3                  ' 
   SW_MINIMIZE = 6                  '    
                                    '  Z-(  
                                    ')
   SW_RESTORE = 9                   '   . 
                                    '   , Windows
                                    '    
                                    '
   SW_SHOW = 5                      ' 
   SW_SHOWMAXIMIZED = 3             '    
   SW_SHOWMINIMIZED = 2             '    
   SW_SHOWMINNOACTIVE = 7           '    . 
                                    '  .
   SW_SHOWNA = 8                    '    .
                                    '   .
   SW_SHOWNOACTIVATE = 4            '     -
                                    '    . -
                                    '   .
End Enum
Private Declare Function _
   ShowWindow Lib "user32" _
   (ByVal hwnd As Long, _
    ByVal nCmdShow As ShowWindowCmd) As Long      '   

Private Declare Function _
   SetActiveWindow Lib "user32" _
   (ByVal hwnd As Long) As Long                   '  ,
                                                  '  .
Private Declare Function _
   GetConsoleWindow Lib "kernel32" () As Long     '  ,
                                                  ' .
Private Declare Function _
   FreeConsole Lib "kernel32" () As Long          '  
                                                  ' .
Private Declare Function _
   CloseHandle Lib "kernel32" ( _
   ByVal hObject As Long) As Long                 '  
                                                  ',   .

Private Const STD_OUTPUT_HANDLE = -11&            '  GetStdHandle.
Private Const STD_INPUT_HANDLE = -10&
Private Const STD_ERROR_HANDLE = -12&
Private Const INVALID_HANDLE_VALUE = -1&
Private Declare Function _
   GetStdHandle Lib "kernel32" ( _
   ByVal nStdHandle As Long) As Long              '  -
                                                  ' , , .
Private Declare Function _
   WriteConsole Lib "kernel32" Alias "WriteConsoleA" ( _
   ByVal hConsoleOutput As Long, _
         lpBuffer As Any, _
   ByVal nNumberOfCharsToWrite As Long, _
         lpNumberOfCharsWritten As Long, _
         lpReserved As Any) As Long               '   
                                                  '   .
Private Declare Function _
   ReadConsole Lib "kernel32" Alias "ReadConsoleA" ( _
   ByVal hConsoleInput As Long, _
   ByVal lpBuffer As String, _
   ByVal nNumberOfCharsToRead As Long, _
         lpNumberOfCharsRead As Long, _
         lpReserved As Any) As Long               '   
                                                  '    
                                                  ' .

Private Declare Function _
   SetConsoleTitle Lib "kernel32" Alias "SetConsoleTitleA" ( _
   ByVal lpConsoleTitle As String) As Long        '  
                                                  '  .
                                                  
Private Declare Function _
   CharToOem Lib "user32" Alias "CharToOemA" ( _
   ByVal lpszSrc As String, _
   ByVal lpszDst As String) As Long               '   win-
                                                  '  dos-.
Private Declare Function _
   OemToChar Lib "user32" Alias "OemToCharA" ( _
   ByVal lpszSrc As String, _
   ByVal lpszDst As String) As Long               '   dos-
                                                  '  win-.
Private hConsoleOut As Long, _
        hConsoleIn As Long, _
        hConsoleErr As Long, _
        hConsoleWind As Long                      ' 

Private Const FOREGROUND_BLUE = &H1               '  
Private Const FOREGROUND_GREEN = &H2              'SetConsoleTextAttribute
Private Const FOREGROUND_RED = &H4                '( wAttributes).
Private Const BACKGROUND_BLUE = &H10
Private Const BACKGROUND_GREEN = &H20
Private Const BACKGROUND_RED = &H40
Private Const BACKGROUND_INTENSITY = &H80&
Private Const FOREGROUND_INTENSITY = &H8&
Private Declare Function _
   SetConsoleTextAttribute Lib "kernel32" ( _
   ByVal hConsoleOutput As Long, _
   ByVal wAttributes As Long) As Long             '    
                                                  ' ,  
                                                  '  WriteConsole.
   
Public Enum ConsoleFontColors       '16   ( )
   FCOL_RedBright = 12              '    DOS
   FCOL_RedDark = 4                 '     ( )
   FCOL_GreenBright = 10
   FCOL_GreenDark = 2
   FCOL_BlueBright = 9
   FCOL_BlueDark = 1
   FCOL_PinkBright = 13
   FCOL_PinkDark = 5
   FCOL_CyanBright = 11
   FCOL_CyanDark = 3
   FCOL_YellowBright = 14
   FCOL_YellowDark = 6
   FCOL_Gray = 8
   FCOL_WhiteStandard = 7
   FCOL_WhiteBright = 15
   FCOL_Black = 0
End Enum
Public Enum ConsoleBackColors      '16   ( )
   BCOL_RedBright = 192
   BCOL_RedDark = 64
   BCOL_GreenBright = 160
   BCOL_GreenDark = 32
   BCOL_BlueBright = 144
   BCOL_BlueDark = 16
   BCOL_PinkBright = 208
   BCOL_PinkDark = 80
   BCOL_CyanBright = 176
   BCOL_CyanDark = 48
   BCOL_YellowBright = 224
   BCOL_YellowDark = 96
   BCOL_Gray = 128
   BCOL_WhiteStandard = 112
   BCOL_WhiteBright = 240
   BCOL_Black = 0
End Enum

Public Enum BorderStyles            '    
   ConsoleBorderSingle = 1          '         |----|
   ConsoleBorderDouble              '           H====H
   ConsoleBorderMix1                ' ( 1) |====|
   ConsoleBorderMix2                ' ( 2) H----H
End Enum
Public BorderStyle As BorderStyles  '  

Public Enum TableLineTypes          '    
   LN_TOP = 1                       '  
   LN_CONTENT                       ' 
   LN_MIDDLE                        ' 
   LN_BOTTOM                        '  
End Enum
Public ConsoleTablesIndent As Byte  '    

Public ReportPath As String  '   
Private sReport As String           ' ,   .
Private bNotHeader As Boolean       '   

Public Sub Load()                                 ' 
   If AllocConsole() Then                         ' .
      hConsoleOut = GetStdHandle( _
         STD_OUTPUT_HANDLE)                       '  -
                                                  ' .
      If hConsoleOut = INVALID_HANDLE_VALUE Then
         MsgBox "    STDOUT"
      End If
      hConsoleIn = GetStdHandle(STD_INPUT_HANDLE) '  -
                                                  ' .
      If hConsoleOut = INVALID_HANDLE_VALUE Then
         MsgBox "    STDIN"
      End If
      hConsoleWind = GetConsoleWindow             '  
                                                  '.
   Else
      MsgBox "  !"
   End If
   
   sReport = "DOS 866 CODEPAGE" & vbCrLf
   If ReportPath = "" Then
      ReportPath = "C:\report.txt"
   End If
   WriteLn HEADER                        '   .
   BorderStyle = ConsoleBorderSingle       '    
   ConsoleTablesIndent = 0                        '  
End Sub

Public Sub Show()                                 ' 
   Dim n As Long
   n = ShowWindow(hConsoleWind, SW_SHOWMAXIMIZED) '  
   n = SetActiveWindow(hConsoleWind)              '  .
End Sub
Public Sub Hide()                                 ' 
   Dim n As Long
   n = ShowWindow(hConsoleWind, SW_HIDE)
End Sub

Private Function fnSpace( _
               ByVal n As Long, _
               ByVal str As String) As String     '  -
   Dim i As Long                                  ' .
   Dim sText As String
   
   sText = ""
   If n > 0 Then
      For i = 1 To n Step 1
         sText = sText & str
      Next i
      fnSpace = sText
   Else
      fnSpace = ""
   End If
End Function

Public Sub Unload()                               '  .
   Dim sAnswer As String * 1        '    
   Dim bSave   As Boolean           '   
   Dim nFile   As Integer
   
   WriteEmptyRows (2)                             '  
question:
   WriteX _
      "   " & ReportPath & _
      " (/)? "                                  '  . .
   sAnswer = ReadLn()
   Select Case sAnswer
   Case "", "", "Y", "y"
      nFile = FreeFile                            ' 
      Open ReportPath For Output As #nFile
      Print #nFile, sReport
      Close #nFile
   Case "", "", "N", "n"
      '  
   Case Else
      GoTo question
   End Select
   
   CloseHandle hConsoleOut
   CloseHandle hConsoleIn
   FreeConsole
End Sub

Public Sub Title(ByVal sTitle As String)   '  .
   SetConsoleTitle fnToDos(sTitle)
End Sub

Public Sub WriteLn( _
              ByVal sInput As String, _
     Optional ByVal bConvertCP As Boolean = True) '    -
                                                  ' .
   WriteX sInput & vbCrLf, bConvertCP
End Sub
Public Sub WriteX( _
              ByVal sInput As String, _
     Optional ByVal bConvertCP As Boolean = True) '  .
     
   Dim cWritten  As Long
   
   If bConvertCP Then sInput = fnToDos(sInput)    '  
                                                  'dos-
   WriteConsole hConsoleOut, ByVal sInput, _
      Len(sInput), cWritten, ByVal 0&             '   .
   
   If bNotHeader Then                             '  -  ,
      sReport = sReport & sInput                  '    .
   Else
      bNotHeader = True
   End If
   DoEvents                                       ' 
End Sub

Public Function ReadLn() As String
   Dim ZeroPos As Long
   ReadLn = String(80, 0)
   ReadConsole hConsoleIn, ReadLn, _
      Len(ReadLn), vbNull, vbNull                 '   .
   ZeroPos = InStr(ReadLn, Chr$(0))
   If ZeroPos > 0 Then
      ReadLn = Left$(ReadLn, ZeroPos - 3)
   End If
   
   sReport = sReport & ReadLn & vbCrLf            '   .
   
   ReadLn = fnToWin(ReadLn)                       '.   win-
   DoEvents                                       ' 
End Function

Public Sub WriteEmptyRows( _
                          Optional Count As Long) '  .
   Dim lC As Long
   If IsMissing(Count) Then Count = 1
   For lC = 1 To Count
      DoEvents
      WriteLn ""
   Next
End Sub

Private Function fnToWin(ByVal sString As String) As String
   Dim sourcestring As String       '  (dos)
   Dim deststring As String         '  (win)
   Dim code As Long
   sourcestring = sString
   deststring = Space$(Len(sourcestring))
   code = OemToChar(sourcestring, deststring)     ' 
   fnToWin = deststring                           ' win-.
End Function

Private Function fnToDos(ByVal sString As String) As String
   Dim sourcestring As String       '  (win)
   Dim deststring As String         '  (dos)
   Dim code As Long
   sourcestring = sString
   deststring = Space$(Len(sourcestring))
   code = CharToOem(sourcestring, deststring)     ' 
   fnToDos = deststring                           ' dos-.
End Function

Public Sub Table( _
              ByVal LineType As TableLineTypes, _
              ByVal Text01 As String, _
     Optional ByVal Text02 As String, _
     Optional ByVal Text03 As String, _
     Optional ByVal Text04 As String, _
     Optional ByVal Text05 As String, _
     Optional ByVal Text06 As String, _
     Optional ByVal Text07 As String, _
     Optional ByVal Text08 As String, _
     Optional ByVal Text09 As String, _
     Optional ByVal Text10 As String, _
     Optional ByVal Text11 As String, _
     Optional ByVal Text12 As String)             '  
   
   Dim aText(1 To 12)         As String '   
   Dim aChar(1 To 11, 1 To 4) As Byte   '   
   Dim i                      As Byte   ' 
   Dim sLine                  As String ' / 
   Dim n                      As Byte   '  
   Dim bFirstCell             As Boolean '   
   
   If Text01 = "" Then Exit Sub                   '  
                                                  ' .
   aText(1) = Text01                              '  -
   aText(2) = Text02                              '   .
   aText(3) = Text03
   aText(4) = Text04
   aText(5) = Text05
   aText(6) = Text06
   aText(7) = Text07
   aText(8) = Text08
   aText(9) = Text09
   aText(10) = Text10
   aText(11) = Text11
   aText(12) = Text12
   
   aChar(1, 1) = 196: aChar(1, 2) = 205           '  
   aChar(2, 1) = 179: aChar(2, 2) = 186           ' 
   aChar(3, 1) = 218: aChar(3, 2) = 201
   aChar(4, 1) = 191: aChar(4, 2) = 187
   aChar(5, 1) = 192: aChar(5, 2) = 200
   aChar(6, 1) = 217: aChar(6, 2) = 188
   aChar(7, 1) = 195: aChar(7, 2) = 204
   aChar(8, 1) = 180: aChar(8, 2) = 185
   aChar(9, 1) = 194: aChar(9, 2) = 203
   aChar(10, 1) = 193: aChar(10, 2) = 202
   aChar(11, 1) = 197: aChar(11, 2) = 206
   
   aChar(1, 3) = 205: aChar(1, 4) = 196           '  
   aChar(2, 3) = 179: aChar(2, 4) = 186           ' 
   aChar(3, 3) = 213: aChar(3, 4) = 214
   aChar(4, 3) = 184: aChar(4, 4) = 183
   aChar(5, 3) = 212: aChar(5, 4) = 211
   aChar(6, 3) = 190: aChar(6, 4) = 189
   aChar(7, 3) = 198: aChar(7, 4) = 199
   aChar(8, 3) = 181: aChar(8, 4) = 182
   aChar(9, 3) = 209: aChar(9, 4) = 210
   aChar(10, 3) = 207: aChar(10, 4) = 208
   aChar(11, 3) = 216: aChar(11, 4) = 215
   
   bFirstCell = True                              '   .
   sLine = fnSpace(ConsoleTablesIndent, " ")      '   
                                                  '.
   Select Case LineType                           '   
   Case TableLineTypes.LN_TOP        '1. 
      For i = 1 To 12 Step 1                      ' .
         n = Len(aText(i))                        '  
         If n Then                                '.
                                                  ',   -
                                                  '    
            If bFirstCell Then                    '.
               sLine = sLine & Chr(aChar(3, BorderStyle))
               bFirstCell = False
            Else
               sLine = sLine & Chr(aChar(9, BorderStyle))
            End If
                                                  '  
            sLine = sLine & fnSpace(n, Chr(aChar(1, BorderStyle)))
         Else                                     '   
                                                   ',   
            sLine = sLine & Chr(aChar(4, BorderStyle))
            Exit For                              '    .
         End If
      Next i
      WriteLn sLine, False
   Case TableLineTypes.LN_MIDDLE     '2. 
      For i = 1 To 12 Step 1                      ' .
         n = Len(aText(i))                        '  
         If n Then                                '.
                                                  ',   -
                                                  '    
            If bFirstCell Then                    '.
               sLine = sLine & Chr(aChar(7, BorderStyle))
               bFirstCell = False
            Else
               sLine = sLine & Chr(aChar(11, BorderStyle))
            End If
                                                  '  
            sLine = sLine & fnSpace(n, Chr(aChar(1, BorderStyle)))
         Else                                     '   
                                                   ',   
            sLine = sLine & Chr(aChar(8, BorderStyle))
            Exit For                              '    .
         End If
      Next i
      WriteLn sLine, False
   Case TableLineTypes.LN_BOTTOM     '3. 
      For i = 1 To 12 Step 1                      ' .
         n = Len(aText(i))                        '  
         If n Then                                '.
                                                  ',   -
                                                  '    
            If bFirstCell Then                    '.
               sLine = sLine & Chr(aChar(5, BorderStyle))
               bFirstCell = False
            Else
               sLine = sLine & Chr(aChar(10, BorderStyle))
            End If
                                                  '  
            sLine = sLine & fnSpace(n, Chr(aChar(1, BorderStyle)))
         Else                                     '   
                                                   ',   
            sLine = sLine & Chr(aChar(6, BorderStyle))
            Exit For                              '    .
         End If
      Next i
      WriteLn sLine, False
   Case TableLineTypes.LN_CONTENT    '4.  
      WriteX sLine                          '  .
      For i = 1 To 12 Step 1                      ' .
         n = Len(aText(i))                        '  
         If n Then                                '.
                                                  '  .
            WriteX Chr(aChar(2, BorderStyle)), False
                                                  '  
            WriteX aText(i)
         Else                                     '   
                                                   ',   
            WriteLn Chr(aChar(2, BorderStyle)), False
            Exit For                              '    .
         End If
      Next i
   End Select
End Sub

Public Sub Color( _
            ByVal FontColor As ConsoleFontColors, _
            ByVal BackColor As ConsoleBackColors) '  .
   
   SetConsoleTextAttribute hConsoleOut, FontColor Or BackColor
End Sub














